import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class ArachnoClaustroPhobia extends PApplet {



Minim minim;
AudioPlayer player;
AudioPlayer scream;
PFont font;
PImage face;
boolean win;
String whowon;
char[] letterOne = { 
  'a', ';', 's', 'l', 'd', 'k', 'f', 'j'
};
char[] letterTwo = {
  'q', 'p', 'w', 'o', 'e', 'i', 'r', 'u'
};
char[] letterThree = {
  'z', '/', 'x', '.', 'c', ',', 'v', 'm'
};

int index;
Spider pOne;
Spider pTwo;
Spider pThree;

public void setup() {
  minim = new Minim(this);
  player = minim.loadFile("flib.wav");
  scream = minim.loadFile("scream.wav");
  player.play();
  player.loop();
  colorMode(HSB);
  font = loadFont("Serif-48.vlw"); 
  textFont(font);
  face = loadImage("face.jpg");
  size(600,600);
  reset();
}


public void draw() {
  if(!win) {
    image(face,random(3),random(3),width,height);
  }
  else {
    //image(face,random(8),random(8),width,height);
    //fill(255,255,255,200);
    //rect(width/2,width/2,width,height);
  }
  
  //show me da spiders
  pOne.display();
  pTwo.display();
  pThree.display();
  
  //win stuff
  if (win) {
    scream.play();
    scream.loop();
    fill(random(255),random(255),random(255));
    text("I love "  +whowon, random(width), random(height));
    colorMode(HSB);
    fill(random(255),255,255);
    text("click mouse to reset", random(3), 400);
  }
  
  // controls display
  fill(150, random(255),random(255));
    text("spider one: qpwoeiru",20,30);
    fill(0,random(255),random(255));
    text("spider two: a;sldkfj", 20, 70);
    fill(40,random(255),random(255));
    text("spider three: z/x.c,vm" ,40, 100);
}


//allow keyboard input only if nobody has won yet
public void keyPressed() {
  if(!win) {
    pOne.walk(key);
    pTwo.walk(key);
    pThree.walk(key);
    scream.pause();
  }
}


// build spiders at default location, set win back to false
public void reset() {
  pOne = new Spider(letterOne, 100,150, "Blue Spider");
  pTwo = new Spider(letterTwo, width/2, 0, "Red Spider");
  pThree = new Spider(letterThree, width-100,40,"Yellow Spider");
  win = false;
}


//activate above reset conditions on click, but only if somebody has won
public void mousePressed() {
  if (win) {

    reset();
  }
}

//stop sound when closing
public void stop()
{
  player.close();
  scream.close();
  minim.stop();
  super.stop();
}

class Spider {
  char[] let;
  float x;
  float y;
  float col;
  String name;
  // constructor
  Spider(char[] tempLet, int tempX, float tempCol, String  tempName) {
    x = tempX;
    let = tempLet;  //variable for array for key controls
    y = height;
    col = tempCol;  //spider color
    name = tempName;  //name for win display text
  }


  //show me the spiders
  public void display() {
    colorMode(HSB);
    fill(col, random(255), random(255));
    // rectMode(CENTER);
    // rect(x, y, 20, 20);
    text(""+let[index], x, y);
  }

  // function which receives a character to test against
  public void walk(char tryKey) {
    if (tryKey == let[index]) {
      print("test "+let[index]+"\n");  //print to console for debugging and escape character
      if (index < let.length-1) {  // make sure im not at the end of the index
        index++;  //progress through the array of characters
        y-=5;  // move spider up
      }
      else {
        index = 0;
        y-=5;
      }
    }
    if (y<=height/2) {  
      win = true;
      whowon = name;
    }
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "ArachnoClaustroPhobia" });
  }
}
